package org.springframework.boot.loader.archive;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.util.Iterator;
import java.util.jar.JarEntry;
import org.springframework.boot.loader.archive.Archive;
import org.springframework.boot.loader.archive.JarFileArchive;

abstract class AbstractIterator<T> implements Iterator<T> {
  private final Iterator<JarEntry> iterator;
  
  private final Archive.EntryFilter searchFilter;
  
  private final Archive.EntryFilter includeFilter;
  
  private Archive.Entry current;
  
  AbstractIterator(Iterator<JarEntry> iterator, Archive.EntryFilter searchFilter, Archive.EntryFilter includeFilter) {
    this.iterator = iterator;
    this.searchFilter = searchFilter;
    this.includeFilter = includeFilter;
    this.current = poll();
  }
  
  public boolean hasNext() {
    return (this.current != null);
  }
  
  public T next() {
    T result = adapt(this.current);
    this.current = poll();
    return result;
  }
  
  private Archive.Entry poll() {
    while (this.iterator.hasNext()) {
      JarFileArchive.JarFileEntry candidate = new JarFileArchive.JarFileEntry(this.iterator.next());
      if ((this.searchFilter == null || this.searchFilter.matches((Archive.Entry)candidate)) && (this.includeFilter == null || this.includeFilter
        .matches((Archive.Entry)candidate)))
        return (Archive.Entry)candidate; 
    } 
    return null;
  }
  
  protected abstract T adapt(Archive.Entry paramEntry);
}
